package uk.ac.cf.spring.demo.sports.match;

import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
//import org.springframework.web.servlet.ModelAndView;

import java.util.List;
@RestController
@RequestMapping("/match")
public class MatchController {
    //tell the Springboot that MatchController depend on MatchService
    private final MatchService matchService;
    @Autowired
    public MatchController(MatchService matchService) {
        this.matchService = matchService;
    }
    // get all Match List
    @GetMapping
    public List<MatchItem> getAllMenuItems() {
        return matchService.getMatchItems();
    }
    //  get Match by id
    @GetMapping("/{id}")
    public MatchItem getMenuItem(@PathVariable Long id) {
        return matchService.getMatchItemById(id);
    }

    // add
    @PostMapping
    public void addMatchItem(@RequestBody MatchItem matchItem) {
        matchService.addMatchItem(matchItem);
    }

    // update
    @PutMapping("/{id}")
    public void updateMatchItem(@PathVariable Long id, @RequestBody MatchItem matchItem) {
        matchItem.setId(id);
        matchService.updateMatchItem(matchItem);
    }

    //delete
    @DeleteMapping("/{id}")
    public void deleteMatchItem(@PathVariable Long id) {
        matchService.deleteMatchItem(id);
    }


    //    @GetMapping("/match")
//    public ModelAndView getMatch() {
//        ModelAndView modelAndView = new ModelAndView("match/allMatchList");
//        List<MatchItem> matchItems = matchService.getMatchItems();
//        modelAndView.addObject("matchItems", matchItems);
//        return modelAndView;
//    }
    // get match through id
//    @GetMapping("/match/{id}")
//    public ModelAndView getMatchItem(@PathVariable Long id) {
//        ModelAndView modelAndView = new ModelAndView("match/matchDetails");
//        MatchItem matchItem = matchService.getMatchItemById(id);
//        modelAndView.addObject("matchItem", matchItem);
//        return modelAndView;
//    }//matchItemForm add match
//    @GetMapping("/match/add")
//    public ModelAndView addMatchItem() {
//        ModelAndView modelAndView = new ModelAndView("match/matchItemForm");
//        MatchItemForm emptyMatchItem = new MatchItemForm();
//        modelAndView.addObject("matchItem", emptyMatchItem);
//        return modelAndView;
//    }

    //
//    @GetMapping("/match/edit/{id}")
//    public ModelAndView editMatchItemTh(@PathVariable("id") Long id) {
//        ModelAndView modelAndView = new ModelAndView("match/matchItemForm");
//        // construct matchToUpdate object to get matchItem by id
//        MatchItem matchToUpdate = matchService.getMatchItemById(id);
//        // Create the form object for the match
//        MatchItemForm matchItemForm = new MatchItemForm(
//                matchToUpdate.getId(),
//                matchToUpdate.getSport(),
//                matchToUpdate.getPlayerAId(),
//                matchToUpdate.getPlayerBId(),
//                matchToUpdate.getPlanTime(),
//                matchToUpdate.getStatus(),
//                matchToUpdate.getScoreA(),
//                matchToUpdate.getScoreB(),
//                matchToUpdate.getConfirmByA(),
//                matchToUpdate.getConfirmByB(),
//                matchToUpdate.getWinnerId()
//        );
//
//        modelAndView.addObject("matchItem", matchItemForm);
//        return modelAndView;
//    }

}
