drop table if exists match_item;
drop table if exists rankings;
create table if not exists match_item (
    -- Match ID
    id BIGINT AUTO_INCREMENT PRIMARY KEY,
    -- Sport type
    sport ENUM('Pools', 'Darts', 'TableTennis') NOT NULL,
    -- Player A ID
    player_AId BIGINT NOT NULL,
    -- Player B ID
    player_BId BIGINT NOT NULL,
    plan_Time DATETIME NOT NULL,
    -- Match status
    status ENUM('pending', 'confirmed', 'completed') DEFAULT 'pending',
    score_a INT DEFAULT 0,
    score_b INT DEFAULT 0,
    confirm_a BOOLEAN DEFAULT FALSE,
    confirm_b BOOLEAN DEFAULT FALSE,
    winner_id BIGINT DEFAULT NULL
    );
drop table if exists information;
CREATE TABLE information (
                             id INT AUTO_INCREMENT PRIMARY KEY,
                             username VARCHAR(50) UNIQUE NOT NULL,
                             email VARCHAR(50) UNIQUE NOT NULL,
                             password VARCHAR(255) NOT NULL,
                             role VARCHAR(20) DEFAULT 'USER' NOT NULL
);
drop table if exists ranking;
CREATE TABLE IF NOT EXISTS ranking (
                                        id INT AUTO_INCREMENT PRIMARY KEY,
                                        user_id INT NOT NULL,
                                        sport ENUM('Pools', 'Darts', 'TableTennis') NOT NULL,
                                        wins INT DEFAULT 0,
                                        username VARCHAR(255)DEFAULT NULL




);
CREATE TABLE images (
                        id INT AUTO_INCREMENT PRIMARY KEY,
                        filename VARCHAR(255) NOT NULL,  -- Image file name or path
                        uploader VARCHAR(100) NOT NULL,  -- Uploader Name
                        upload_time TIMESTAMP DEFAULT CURRENT_TIMESTAMP -- Upload time
);
